theory AxTest = AxSem:

ML {*
fun inst1_tac s t = instantiate_tac [(s,t)];
val ax_tac = REPEAT o rtac allI THEN'
             resolve_tac(thm "ax_Skip"::thm "ax_StatRef"::thm "ax_MethdN"::
                         thm "ax_Alloc"::thm "ax_Alloc_Arr"::
                         thm "ax_SXAlloc_Normal"::
                         funpow 7 tl (thms "ax_derivs.intros"))
*}

lemma normal_out: "(Normal Q)\<leftarrow>v = Normal (Q\<leftarrow>v)"
by simp

lemma test: "G,({}::'a triple set)\<turnstile> 
       {Normal (\<lambda> Y s Z. True)} 
       BinOp Plus (Lit (Intg 2)) (Lit (Intg 5))-\<succ>
       {\<lambda>Y s Z::'a. Y=(In1 (Intg 7))}"
apply (rule ax_derivs.BinOp)
prefer 2
apply (tactic {* inst1_tac "Q" "Normal ?R" *})
apply (simp only: normal_out)
apply (rule allI)
apply (rule conseq1)
apply (rule ax_derivs.Lit)
apply simp
prefer 2
apply (rule conseq2)
apply (rule ax_Lit2)
apply (tactic {* inst1_tac "R" "\<lambda> Y s Z. Y = In1 (Intg 2)" *})
apply   simp
apply   simp
done
